searchData={"items":[{"type":"module","title":"Regulator","doc":"Adaptive concurrency limits.","ref":"Regulator.html"},{"type":"function","title":"Regulator.ask/1","doc":"Ask for access to a protected service. Instead of executing a callback this\nfunction returns a `dropped` atom or a context. It is the callers responsibility\nto check the context map back in to the regulator using one of the corresponding\nfunctions. Care must be taken to avoid leaking these contexts. Otherwise the\nregulator will not be able to adjust the inflight count which will eventually\ndeadlock the regulator.","ref":"Regulator.html#ask/1"},{"type":"function","title":"Regulator.ask/2","doc":"Ask for access to a protected service. If we've reached the concurrency limit\nthen `ask` will return a `:dropped` atom without executing the callback. Otherwise\nthe callback will be applied. The callback must return tuple with the result\nas the first element and the desired return value as the second. The available\nresult atoms are:\n\n* `:ok` - The call succeeded.\n* `:error` - The call failed or timed out. This is used as a signal to backoff or otherwise adjust the limit.\n* `:ignore` - The call should not be counted in the concurrency limit. This is typically used to filter out status checks and other low latency RPCs.","ref":"Regulator.html#ask/2"},{"type":"function","title":"Regulator.error/1","doc":"Checks in a context and marks it as an error.","ref":"Regulator.html#error/1"},{"type":"function","title":"Regulator.ignore/1","doc":"Checks in a context and ignores the result.","ref":"Regulator.html#ignore/1"},{"type":"function","title":"Regulator.install/2","doc":"Creates a new regulator.","ref":"Regulator.html#install/2"},{"type":"function","title":"Regulator.ok/1","doc":"Checks in a context and marks it as \"ok\".","ref":"Regulator.html#ok/1"},{"type":"function","title":"Regulator.uninstall/1","doc":"Removes a regulator.","ref":"Regulator.html#uninstall/1"},{"type":"type","title":"Regulator.result/0","doc":"","ref":"Regulator.html#t:result/0"},{"type":"type","title":"Regulator.token/0","doc":"","ref":"Regulator.html#t:token/0"},{"type":"behaviour","title":"Regulator.Limit","doc":"Provides a behaviour for defining new limit algorithms","ref":"Regulator.Limit.html"},{"type":"callback","title":"Regulator.Limit.initial/1","doc":"The initial limit.","ref":"Regulator.Limit.html#c:initial/1"},{"type":"callback","title":"Regulator.Limit.new/1","doc":"Creates a new limit configuration.","ref":"Regulator.Limit.html#c:new/1"},{"type":"callback","title":"Regulator.Limit.update/3","doc":"Recalculates the new limit based on the previous limit, the most\nrecent window, and the configuration for the limit. Must return the\nlimit configuration with the new limit in a tuple.","ref":"Regulator.Limit.html#c:update/3"},{"type":"module","title":"Regulator.Limit.AIMD","doc":"Loss based dynamic limit algorithm. Additively increases the concurrency\nlimit when there are no errors and multiplicatively decrements the limit\nwhen there are errors.\n\nTo use this regulator you must specify a \"target average latency\". Regulator collects\nmeasurements of your service calls and averages them over a sliding window. If the\naverage latency is above the target specified, regulator considers it an error\nand will begin to multiplicatively decrease the concurrency limit. If the avg latency\nis *below* the target **and** over half of the concurrency tokens were utilized\nduring the window, then regulator will increase the concurrency limit by a fixed value.\nIf less than half of the concurrency tokens were utilized in the window, Regulator\nleaves the concurrency limit as is, since there is no need for additional tokens.\n\nFinally, if there was any errors that occured during the window, Regulator treats that\nas a backoff situation and will begin to reduce the concurrency limit.","ref":"Regulator.Limit.AIMD.html"},{"type":"module","title":"Options - Regulator.Limit.AIMD","doc":"* `:min_limit` - The minimum concurrency limit (defaults to 5)\n* `:initial_limit` - The initial concurrency limit when the regulator is installed (deafults to 20)\n* `:max_limit` - The maximum concurrency limit (defaults to 200)\n* `:step_increase` - The number of tokens to add when regulator is increasing the concurrency limit (defaults to 10).\n* `:backoff_ratio` - Floating point value for how quickly to reduce the concurrency limit (defaults to 0.9)\n* `:target_avg_latency` - This is the average latency in milliseconds for the system regulator is protecting. If the average latency drifts above this value Regulator considers it an error and backs off. Defaults to 5.\n* `:timeout` - alias for `target_avg_latency`.","ref":"Regulator.Limit.AIMD.html#module-options"},{"type":"module","title":"Regulator.Limit.Gradient","doc":"Limiter based on the gradient of change. Based on Netflix's gradient2 algorithm.\nhttps://github.com/Netflix/concurrency-limits.","ref":"Regulator.Limit.Gradient.html"},{"type":"module","title":"Options - Regulator.Limit.Gradient","doc":"* `:initial_limit` - The initial limit when the regulator is installed (defaults to 20).\n* `:min_limit` - The minimum limit for the regulator (defaults to 5).\n* `:max_limit` - The maximum limit for the regulator (defaults to 200).\n* `:smoothing` - Determines how aggressively the concurrency limit can shrink\n  if there is queueing. Numbers should be between 0.0 and 1.0. Higher numbers\n  will cause the limit to shrink faster.\n* `:rtt_tolerance` - Specifies how much change in average round trip time will\n  be allowed before reducing the concurrency limit. A value of 2.0 would mean\n  that a 2x increase in rtt would be acceptable. Default 1.5.\n* `:long_window_count` - Defines the number of sample windows that will be considered in the long term moving average. Setting this value lower will cause the long term window to adjust more aggressively. Default 600.","ref":"Regulator.Limit.Gradient.html#module-options"},{"type":"module","title":"Regulator.Limit.Static","doc":"Fixed limit","ref":"Regulator.Limit.Static.html"},{"type":"module","title":"Options - Regulator.Limit.Static","doc":"* `:limit` - Statically defined limit","ref":"Regulator.Limit.Static.html#module-options"},{"type":"module","title":"Regulator.Plug","doc":"A plug used for regulating the concurrency limit of an endpoint or series of\nendpoints.","ref":"Regulator.Plug.html"},{"type":"module","title":"Options - Regulator.Plug","doc":"* `:regulator` - Required. The regulator to use for this plug.\n* `:error_code` - The status code to use when the concurrency limit is reached. Defaults to 403.\n* `:error_message` - The message to return when the concurrency limit is reached. Must be a binary. Defaults to \"Overloaded\".","ref":"Regulator.Plug.html#module-options"},{"type":"function","title":"Regulator.Plug.call/2","doc":"","ref":"Regulator.Plug.html#call/2"},{"type":"function","title":"Regulator.Plug.init/1","doc":"","ref":"Regulator.Plug.html#init/1"},{"type":"module","title":"Regulator.Telemetry","doc":"Regulator produces multiple telemetry events.","ref":"Regulator.Telemetry.html"},{"type":"module","title":"Events - Regulator.Telemetry","doc":"* `[:regulator, :limit]` - Returns the calculated limit\n\n  ##","ref":"Regulator.Telemetry.html#module-events"},{"type":"module","title":"Measurements - Regulator.Telemetry","doc":"* `:limit` - The new limit\n\n  ##","ref":"Regulator.Telemetry.html#module-measurements"},{"type":"module","title":"Metadata - Regulator.Telemetry","doc":"* `:regulator` - The name of the regulator\n\n* `[:regulator, :ask, :start]` - Is called when asking for access to a protected service\n\n  ##","ref":"Regulator.Telemetry.html#module-metadata"},{"type":"module","title":"Measurements - Regulator.Telemetry","doc":"* `:inflight` - The current inflight requests\n    * `:system_time` - The current, monotonic system time\n\n  ##","ref":"Regulator.Telemetry.html#module-measurements"},{"type":"module","title":"Metadata - Regulator.Telemetry","doc":"* `:regulator` - The regulator name\n\n* `[:regulator, :ask, :stop]` - Called immediately before an `ask` call returns.\n\n  ##","ref":"Regulator.Telemetry.html#module-metadata"},{"type":"module","title":"Measurements - Regulator.Telemetry","doc":"* `:duration` - The amount of time taken in the regulator\n\n  ##","ref":"Regulator.Telemetry.html#module-measurements"},{"type":"module","title":"Metadata - Regulator.Telemetry","doc":"* `:regulator` - The name of the regulator\n    * `:result` - The result of the call, either `:ok`, `:dropped`, `:error`, or `:ignore`\n\n* `[:regulator, :ask, :exception]` - Called if the callback passed to `ask` raises or throws\n\n  ##","ref":"Regulator.Telemetry.html#module-metadata"},{"type":"module","title":"Measurements - Regulator.Telemetry","doc":"* `:duration` - The amount of time taken in the regulator\n\n  ##","ref":"Regulator.Telemetry.html#module-measurements"},{"type":"module","title":"Metadata - Regulator.Telemetry","doc":"* `:kind` - The type of error\n    * `:error` - The error\n    * `:stacktrace` - The stacktrace\n    * `:regulator` - The regulator name","ref":"Regulator.Telemetry.html#module-metadata"}],"content_type":"text/markdown"}